diff --git a/build.gradle.kts b/build.gradle.kts
index c343d02fe..bccdb3470 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -89,6 +89,14 @@ repositories {
         }
         metadataSources { artifact() }
     }
+    ivy {
+        url = uri("https://github.com/Turnip-Labs")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/[module]-bta-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
     jcenter()
 }
 
@@ -121,12 +129,7 @@ val lwjglNatives = Pair(
 }
 dependencies {
     implementation("org.jetbrains:annotations:24.0.0")?.let { clientInclude(it); serverInclude(it) }
-    implementation("com.github.Zarzelcow:legacy-lwjgl3:78643b2a96") {
-        exclude(group = "net.fabricmc")
-        exclude(group = "org.lwjgl")
-        exclude(group = "org.jetbrains.kotlin")
-        exclude(group = "org.javassist")
-    }.let { clientInclude(it) }
+    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.0")?.let { clientInclude(it) }
     implementation(platform("org.lwjgl:lwjgl-bom:$lwjglVersion"))
 
     implementation("org.lwjgl", "lwjgl")
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index d9d1eaf00..80dc10273 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -8,6 +8,7 @@ import java.awt.event.MouseAdapter;
 import java.awt.event.MouseEvent;
 import java.io.File;
 import java.io.IOException;
+import java.time.ZoneId;
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Comparator;
@@ -24,6 +25,7 @@ import net.minecraft.client.gui.achievements.AchievementsScreen;
 import net.minecraft.client.gui.chat.ChatScreen;
 import net.minecraft.client.gui.chat.SleepScreenMP;
 import net.minecraft.client.gui.toasts.HudToastsElement;
+import net.minecraft.client.holiday.Holidays;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.util.helper.LoggedPrintStream;
@@ -265,7 +267,6 @@ public class Minecraft
     {
     	this.gameWindow = gameWindow;
         this.resolution = new ScaledResolution(this.gameWindow);
-    	
         Global.accessor = this;
         LoggedPrintStream.wrapStreams();
         hasCrashed = false;
@@ -405,6 +406,8 @@ public class Minecraft
 
 		mcDataDir = getMinecraftDir();
 
+        Holidays.initialize();
+
         // Manually initialize blocks and items
         Blocks.init();
         Items.init();
@@ -1217,7 +1220,7 @@ public class Minecraft
                         break bridge;
                     }
                     if (stack.stackSize <= 0) {
-                        this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
+                        this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.getCurrentItemIndex()] = null;
                     } else if (stack.stackSize != numItemsInStack) {
                         worldRenderer.itemRenderer.updateEquippedItem();
                     }
@@ -1261,7 +1264,9 @@ public class Minecraft
             if(clickType == 0)
             {
                 playerController.startDestroyBlock(blockX, blockY, blockZ, objectMouseOver.side, xPlaced, yPlaced, repeat);
-                playerController.swingItem(true);
+                if (thePlayer.getHeldObject() == null) {
+                    playerController.swingItem(true);
+                }
             } else
             {
                 ItemStack stack = thePlayer.inventory.getCurrentItem();
@@ -1277,7 +1282,7 @@ public class Minecraft
                 }
                 if(stack.stackSize <= 0)
                 {
-                    thePlayer.inventory.mainInventory[thePlayer.inventory.currentItem] = null;
+                    thePlayer.inventory.mainInventory[thePlayer.inventory.getCurrentItemIndex()] = null;
                 }
                 else if(stack.stackSize != numItemsInStack)
                 {
@@ -1817,15 +1822,17 @@ public class Minecraft
 
         // Hotbar switch
         if (gameSettings.keyHotBarSwitch.isPressEvent(currentInputDevice)) {
-            if (shift) {
-                thePlayer.setHotbarOffset((thePlayer.inventory.hotbarOffset + 27) % (36));
-                hotbarSwapAnimationProgress = -1.0f;
-            }
-            else {
-                thePlayer.setHotbarOffset((thePlayer.inventory.hotbarOffset + 9) % (36));
-                hotbarSwapAnimationProgress = 1.0f;
+            if (!thePlayer.inventory.currentItemLocked()) {
+                if (shift) {
+                    thePlayer.setHotbarOffset((thePlayer.inventory.getHotbarOffset() + 27) % (36));
+                    hotbarSwapAnimationProgress = -1.0f;
+                }
+                else {
+                    thePlayer.setHotbarOffset((thePlayer.inventory.getHotbarOffset() + 9) % (36));
+                    hotbarSwapAnimationProgress = 1.0f;
+                }
+                thePlayer.inventory.changeCurrentItem(0);
             }
-            thePlayer.inventory.changeCurrentItem(0);
             return true;
         }
 
@@ -1906,7 +1913,7 @@ public class Minecraft
         };
         for(int i = 0; i < hotbarSlots.length; i++) {
             if (hotbarSlots[i].isPressEvent(currentInputDevice)) {
-                thePlayer.inventory.currentItem = i + thePlayer.inventory.hotbarOffset;
+                thePlayer.inventory.setCurrentItemIndex(i + thePlayer.inventory.getHotbarOffset(), false);
                 return true;
             }
         }
@@ -1988,14 +1995,18 @@ public class Minecraft
                 displayScreen(new PauseScreen());
             }
             if(controller.digitalPad.up.pressedThisFrame()) {
-                thePlayer.setHotbarOffset((thePlayer.inventory.hotbarOffset + 27) % (36));
-                hotbarSwapAnimationProgress = -1.0f;
-                thePlayer.inventory.changeCurrentItem(0);
+                if (!thePlayer.inventory.currentItemLocked()) {
+                    thePlayer.setHotbarOffset((thePlayer.inventory.getHotbarOffset() + 27) % (36));
+                    hotbarSwapAnimationProgress = -1.0f;
+                    thePlayer.inventory.changeCurrentItem(0);
+                }
             }
             if(controller.digitalPad.down.pressedThisFrame()) {
-                thePlayer.setHotbarOffset((thePlayer.inventory.hotbarOffset + 9) % (36));
-                hotbarSwapAnimationProgress = 1.0f;
-                thePlayer.inventory.changeCurrentItem(0);
+                if (!thePlayer.inventory.currentItemLocked()) {
+                    thePlayer.setHotbarOffset((thePlayer.inventory.getHotbarOffset() + 9) % (36));
+                    hotbarSwapAnimationProgress = 1.0f;
+                    thePlayer.inventory.changeCurrentItem(0);
+                }
             }
             if(controller.digitalPad.left.pressedThisFrame() && thePlayer.getGamemode().canPlayerFly()) {
                 thePlayer.setNoclip(!thePlayer.noPhysics);
@@ -2388,19 +2399,19 @@ public class Minecraft
         return "P: " + particleEngine.countParticles() + ". T: " + theWorld.getNumLoadedEntitiesString();
     }
 
-    public void respawn(boolean flag, int i)
+    public void respawn(boolean multiplayer, int targetDimension)
     {
-    	Player previousPlayer = thePlayer;
+    	@Nullable Player previousPlayer = thePlayer;
         if(!theWorld.isClientSide && !theWorld.dimension.defaultWorldType.mayRespawn())
         {
-            usePortal(i);
+            usePortal(targetDimension);
         }
 
         ChunkCoordinates spawnCoordinates = null;
         ChunkCoordinates bedSpawnCoordinates = null;
         ChunkCoordinates lastDeathCoordinates = null;
         boolean canRespawnAtBed = true;
-        if(thePlayer != null && !flag)
+        if(thePlayer != null && !multiplayer)
         {
             spawnCoordinates = thePlayer.getPlayerSpawnCoordinate();
             lastDeathCoordinates = thePlayer.getLastDeathCoordinate();
@@ -2435,13 +2446,18 @@ public class Minecraft
             playerGamemode = thePlayer.getGamemode();
         }
         thePlayer = (LocalPlayer)playerController.createPlayer(theWorld);
-        thePlayer.dimension = i;
+        thePlayer.dimension = targetDimension;
         thePlayer.setGamemode(playerGamemode);
-        thePlayer.messageHistory = previousPlayer.messageHistory;
+        if (previousPlayer != null && previousPlayer.getHeldObject() != null) {
+            thePlayer.setHeldObject(previousPlayer.getHeldObject());
+            thePlayer.inventory.setCurrentItemIndex(previousPlayer.inventory.getCurrentItemIndex(), true);
+            thePlayer.inventory.setHotbarOffset(previousPlayer.inventory.getHotbarOffset(), true);
+        }
         activeCamera = new EntityCameraFirstPerson(this, thePlayer);
         thePlayer.resetPos();
         
         if(previousPlayer != null) {
+            thePlayer.messageHistory = previousPlayer.messageHistory;
         	if(!theWorld.isClientSide) {
         		thePlayer.inventory.transferAllContents(previousPlayer.inventory);
         	}
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 745fc3481..10fa3233e 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -71,6 +71,7 @@ public class LocalPlayer extends Player
     public float getFovModifier() {
         float f = 1.0f;
         f *= ((speed * 1.0f) / baseSpeed + 1.0f) / 2.0f; // sprinting
+        f *= heldObject == null ? 1f : 0.8f; // Slightly decrease fov while holding carried object
         return f;
     }
 
diff --git a/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java b/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
index 4e08e4566..f10f7d695 100644
--- a/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
@@ -129,19 +129,19 @@ public class RemotePlayer extends Player
     }
 
     @Override
-	public void setEquippedSlot(int i, int j, int k, CompoundTag tag)
+	public void setEquippedSlot(int slot, int itemID, int itemMeta, CompoundTag tag)
     {
         ItemStack itemstack = null;
-        if(j >= 0)
+        if(itemID >= 0)
         {
-            itemstack = new ItemStack(j, 1, k, tag);
+            itemstack = new ItemStack(itemID, 1, itemMeta, tag);
         }
-        if(i == 0)
+        if(slot == 0)
         {
-            inventory.mainInventory[inventory.currentItem] = itemstack;
+            inventory.mainInventory[inventory.getCurrentItemIndex()] = itemstack;
         } else
         {
-            inventory.armorInventory[i - 1] = itemstack;
+            inventory.armorInventory[slot - 1] = itemstack;
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index 32e54b30f..b23d0f8b8 100644
--- a/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -33,7 +33,7 @@ public class HeldItemTooltipElement extends Gui {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 			
 			int id = getItemID(item);
-			int i = mc.thePlayer.inventory.currentItem;
+			int i = mc.thePlayer.inventory.getCurrentItemIndex();
 			
 			if(id != lastItemID || i != lastSelectedItem) {
 				updateString(item);
@@ -52,7 +52,7 @@ public class HeldItemTooltipElement extends Gui {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
 			int id = getItemID(item);
-			int i = mc.thePlayer.inventory.currentItem;
+			int i = mc.thePlayer.inventory.getCurrentItemIndex();
 
 			if(id != lastItemID || i != lastSelectedItem) {
 				updateString(item);
diff --git a/src/main/java/net/minecraft/client/gui/MainMenuScreen.java b/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
index 4edcdc490..70e805cf0 100644
--- a/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
+++ b/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
@@ -18,6 +18,7 @@ import javax.imageio.ImageIO;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.hud.IngameHud;
 import net.minecraft.client.gui.hud.DoomIngameHud;
+import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -125,33 +126,31 @@ public class MainMenuScreen extends Screen
     {
         I18n i18n = I18n.getInstance();
 
-        Calendar calendar = Calendar.getInstance();
-        calendar.setTime(new Date());
-        if (calendar.get(Calendar.MONTH) + 1 == 1 && calendar.get(Calendar.DATE) == 19)
+        if (Holidays.ANNIVERSARY_JONKADELIC.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.jonkadelic_birthday");
         }
-        else if (calendar.get(Calendar.MONTH) + 1 == 4 && calendar.get(Calendar.DATE) == 29)
+        else if (Holidays.ANNIVERSARY_MAGGANDGEEZ.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.maggandgeez_birthday");
         }
-        else if (calendar.get(Calendar.MONTH) + 1 == 5 && calendar.get(Calendar.DATE) == 17)
+        else if (Holidays.ANNIVERSARY_MINECRAFT.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.minecraft_birthday");
         }
-        else if (calendar.get(Calendar.MONTH) + 1 == 7 && calendar.get(Calendar.DATE) == 20)
+        else if (Holidays.ANNIVERSARY_BTA.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.bta_birthday");
         }
-        else if (calendar.get(Calendar.MONTH) + 1 == 12 && calendar.get(Calendar.DATE) == 24)
+        else if (Holidays.XMAS.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.xmas");
         }
-        else if (calendar.get(Calendar.MONTH) + 1 == 1 && calendar.get(Calendar.DATE) == 1)
+        else if (Holidays.NEW_YEAR.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.new_year");
         }
-        else if (calendar.get(Calendar.MONTH) + 1 == 10 && calendar.get(Calendar.DATE) == 31)
+        else if (Holidays.HALLOWEEN.isActive())
         {
             splashText = i18n.translateKey("gui.main_menu.label.splash.halloween");
         }
diff --git a/src/main/java/net/minecraft/client/gui/container/InventoryScreen.java b/src/main/java/net/minecraft/client/gui/container/InventoryScreen.java
index 656915880..3da55e4d7 100644
--- a/src/main/java/net/minecraft/client/gui/container/InventoryScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/InventoryScreen.java
@@ -264,6 +264,14 @@ public class InventoryScreen extends AbstractContainerScreen
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
+        if (mc.thePlayer.inventory.currentItemLocked()) {
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/sprites/slot_locked.png").bind();
+            int xOff = (18 * (mc.thePlayer.inventory.getCurrentItemIndex() % 9));
+            int hotbar = (((mc.thePlayer.inventory.getHotbarOffset() + 27) / 9) % 4);
+            int yOff = (18 * hotbar) + ((hotbar == 3) ? 4 : 0);
+            drawTexturedModalRect(j + 7 + xOff, k + 83 + yOff, 0, 0, 18, 18, 1f/18, 1f/18);
+        }
+
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glEnable(GL11.GL_COLOR_MATERIAL);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
diff --git a/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java b/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
index 6bf894b2a..70cb0b08e 100644
--- a/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
+++ b/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
@@ -183,6 +183,13 @@ public class InventoryScreenCreative extends InventoryScreen implements ITextCha
         searchField.xPosition = x + 183;
         searchField.yPosition = y + 7;
         drawTexturedModalRect((double)x, (double)y, 0, 0, xSize, ySize, xSize / 2, ySize / 2);
+		if (mc.thePlayer.inventory.currentItemLocked()) {
+			mc.textureManager.loadTexture("/assets/minecraft/textures/gui/sprites/slot_locked.png").bind();
+			int xOff = (18 * (mc.thePlayer.inventory.getCurrentItemIndex() % 9));
+			int hotbar = (((mc.thePlayer.inventory.getHotbarOffset() + 27) / 9) % 4);
+			int yOff = (18 * hotbar) + ((hotbar == 3) ? 4 : 0);
+			drawTexturedModalRect(x + 7 + xOff, y + 83 + yOff, 0, 0, 18, 18, 1f/18, 1f/18);
+		}
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glEnable(GL11.GL_COLOR_MATERIAL);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
diff --git a/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java b/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
index 73e6788cb..af5b68453 100644
--- a/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
+++ b/src/main/java/net/minecraft/client/gui/hud/DoomIngameHud.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
@@ -88,12 +89,15 @@ public class DoomIngameHud
         mc.textureManager.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
 
         // Draw main hotbar
-        drawTexturedModalRect(width / 2 - 197, height - 43, 0, 0, 197, 43);
-        drawTexturedModalRect(width / 2, height - 43, 0, 43, 197, 43);
+        drawTexturedModalRectDouble(width / 2d - 197d, height - 43, 0, 0, 197, 43, 1/256d, 1/256d, 0);
+        drawTexturedModalRectDouble(width / 2d, height - 43, 0, 43, 197, 43, 1/256d, 1/256d, 0);
 
         // Draw sides
-        drawTexturedModalRect(0d, height - 43, 0, 86, width / 2 - 197, 43, 1, 43);
-        drawTexturedModalRect(width / 2d + 197d, height - 43, 0, 86, width - (width / 2 + 197), 43, 1, 43);
+        int loops = (int) Math.ceil((((width/2d) - 197)/128));
+        for (int i = 0; i < loops; i++) {
+            drawTexturedModalRectDouble((width / 2d) - 197 - 128 * (i + 1), height - 43, 0, 86, 128, 43, 128, 43, 1/256f, 1/256f);
+            drawTexturedModalRectDouble((width / 2d) + 197d + 128 * i, height - 43, 0, 129 - 43, 128, 43, 128, 43, 1/256f, 1/256f);
+        }
     }
 
     private void drawFace()
@@ -185,7 +189,7 @@ public class DoomIngameHud
         int height = mc.resolution.getScaledHeightScreenCoords();
 
         int i = 1;
-        int activeSlot = mc.thePlayer.inventory.currentItem % 9;
+        int activeSlot = mc.thePlayer.inventory.getCurrentItemIndex() % 9;
         for (int y = 0; y < 2; y++)
         {
             for (int x = 0; x < 5; x++)
@@ -243,7 +247,7 @@ public class DoomIngameHud
         int x = width / 2 + 76;
         int y = height - 36;
 
-        int selectedHotbar = ((mc.thePlayer.inventory.hotbarOffset + 27) % 36) / 9;
+        int selectedHotbar = ((mc.thePlayer.inventory.getHotbarOffset() + 27) % 36) / 9;
 
         drawTexturedModalRect(x, y + 9 * selectedHotbar, 0, 129, 6, 6);
     }
@@ -253,8 +257,8 @@ public class DoomIngameHud
         int width = mc.resolution.getScaledWidthScreenCoords();
         int height = mc.resolution.getScaledHeightScreenCoords();
 
-        int currentItem = mc.thePlayer.inventory.currentItem;
-        int wrappedCurrentItem = mc.thePlayer.inventory.currentItem % 9;
+        int currentItem = mc.thePlayer.inventory.getCurrentItemIndex();
+        int wrappedCurrentItem = mc.thePlayer.inventory.getCurrentItemIndex() % 9;
 
         int offset = 0;
         if (wrappedCurrentItem >= 5)
diff --git a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
index 3229148c5..53ccc13aa 100644
--- a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
+++ b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
@@ -397,6 +397,9 @@ public class IngameHud extends Gui
                             drawDebugScreenLineRight("Light: Sky: " + mc.theWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ) + " Block: " + mc.theWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ));
                         }
 
+                        drawDebugScreenLineRight("Signal: " + mc.theWorld.getSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
+                        drawDebugScreenLineRight("Direct signal: " + mc.theWorld.getDirectSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
+
                         for (Tag<Block> tag : BlockTags.TAG_LIST)
                         {
                             if (tag.appliesTo(block))
diff --git a/src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java
index 6b5f56cea..435aeaabf 100644
--- a/src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java
@@ -66,7 +66,7 @@ public class HotbarComponent
 
 
         // Render hotbar switcher and dots
-        int selectedHotbar = ((inv.hotbarOffset + 27) % 36) / 9;
+        int selectedHotbar = ((inv.getHotbarOffset() + 27) % 36) / 9;
         IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector");
         hud.drawIconTexture(x, y, x + 6, y + 22, 0, 0, 6, 22, coordinate);
         hud.drawIconTexture(x, y + selectedHotbar * 5, x + 6, y + selectedHotbar * 5 + 5, 6, selectedHotbar * 5, 12, selectedHotbar * 5 + 5, coordinate);
@@ -76,8 +76,8 @@ public class HotbarComponent
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         Lighting.enableInventoryLight();
-        int lastHotbarStart = (mc.thePlayer.inventory.hotbarOffset + 27) % 36;
-        int nextHotbarStart = (mc.thePlayer.inventory.hotbarOffset + 9) % 36;
+        int lastHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + 27) % 36;
+        int nextHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + 9) % 36;
 
         // Render hotbars being switched if appropriate
         if (mc.hotbarSwapAnimationProgress != 0.0f) {
@@ -115,7 +115,7 @@ public class HotbarComponent
         for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
             int itemX = x + 8 + itemIndex * 20;
             int itemY = y + 3 + (int) (22 * mc.hotbarSwapAnimationProgress);
-            renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.hotbarOffset, itemX, itemY, partialTick);
+            renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
         }
 
         Scissor.disable();
@@ -125,7 +125,7 @@ public class HotbarComponent
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
 
         // Render selector
-        hud.drawGuiIcon((x + 4) + (inv.currentItem % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selection"));
+        hud.drawGuiIcon((x + 4) + (inv.getCurrentItemIndex() % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
 
         hud.heldItemTooltipElement.updateAndRender(mc, x + 187/2, y - 20);
     }
diff --git a/src/main/java/net/minecraft/client/holiday/Holiday.java b/src/main/java/net/minecraft/client/holiday/Holiday.java
new file mode 100644
index 000000000..d3be6b828
--- /dev/null
+++ b/src/main/java/net/minecraft/client/holiday/Holiday.java
@@ -0,0 +1,52 @@
+package net.minecraft.client.holiday;
+
+import java.time.Month;
+import java.time.ZoneId;
+import java.util.Calendar;
+import java.util.Date;
+import java.util.Locale;
+import java.util.TimeZone;
+
+public class Holiday {
+    protected int month;
+    protected int day;
+    protected String resourcePath = null;
+    public Holiday(Month month, int day) {
+        this.month = month.ordinal();
+        this.day = day;
+        Holidays.allHolidays.add(this);
+    }
+
+    public Holiday setCustomResourcePath(String path) {
+        if (path == null) {
+            Holidays.allThemedHolidays.remove(this);
+        } else {
+            Holidays.allThemedHolidays.add(this);
+        }
+        this.resourcePath = path;
+        return this;
+    }
+
+    public boolean hasCustomResources() {
+        return resourcePath != null;
+    }
+
+    public String getCustomResourcesSubPath() {
+        return resourcePath;
+    }
+
+    public boolean isActive() {
+        Calendar c = getLocalCalendar();
+        return c.get(Calendar.MONTH) == month && c.get(Calendar.DAY_OF_MONTH) == day;
+    }
+
+    public static Calendar getLocalCalendar() {
+        return Calendar.getInstance(TimeZone.getTimeZone(ZoneId.systemDefault()), Locale.getDefault());
+    }
+
+    public static Date getLocalDate(int year, int month, int day) {
+        Calendar c = getLocalCalendar();
+        c.set(year, month, day);
+        return c.getTime();
+    }
+}
diff --git a/src/main/java/net/minecraft/client/holiday/Holidays.java b/src/main/java/net/minecraft/client/holiday/Holidays.java
new file mode 100644
index 000000000..d5d644783
--- /dev/null
+++ b/src/main/java/net/minecraft/client/holiday/Holidays.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.holiday;
+
+import java.time.Month;
+import java.util.ArrayList;
+import java.util.List;
+
+public class Holidays {
+    public static final List<Holiday> allHolidays = new ArrayList<>();
+    public static final List<Holiday> allThemedHolidays = new ArrayList<>();
+
+    public static final Holiday HALLOWEEN = new Holiday(Month.OCTOBER, 31).setCustomResourcePath("halloween");
+    public static final Holiday XMAS = new Holiday(Month.DECEMBER, 25).setCustomResourcePath("xmas");
+    public static final Holiday NEW_YEAR = new Holiday(Month.JANUARY, 1);
+
+    public static final Holiday ANNIVERSARY_MINECRAFT = new Holiday(Month.MAY, 17);
+    public static final Holiday ANNIVERSARY_BTA = new Holiday(Month.JULY, 20);
+
+    public static final Holiday ANNIVERSARY_JONKADELIC = new Holiday(Month.JANUARY, 19);
+    public static final Holiday ANNIVERSARY_MAGGANDGEEZ = new Holiday(Month.APRIL, 29);
+
+    private static Holiday currentThemedHoliday;
+
+    public static Holiday getCurrentThemedHoliday() {
+        return currentThemedHoliday;
+    }
+
+    public static void initialize() {
+
+        for (Holiday holiday : allThemedHolidays) {
+            if (holiday.isActive()) {
+                currentThemedHoliday = holiday;
+                break;
+            }
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index 7c4ca71ac..32de69b52 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -54,6 +54,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.RSA;
 import net.minecraft.core.world.Explosion;
 import net.minecraft.core.world.ExplosionCannonball;
+import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.data.SynchedEntityData;
@@ -306,16 +307,18 @@ public class ClientPacketHandler extends PacketHandler
         int i = playerPacket.currentItem;
         if (i == 0)
         {
-            remotePlayer.inventory.mainInventory[remotePlayer.inventory.currentItem] = null;
+            remotePlayer.inventory.mainInventory[remotePlayer.inventory.getCurrentItemIndex()] = null;
         }
         else
         {
-            remotePlayer.inventory.mainInventory[remotePlayer.inventory.currentItem] = new ItemStack(i, 1, 0);
+            remotePlayer.inventory.mainInventory[remotePlayer.inventory.getCurrentItemIndex()] = new ItemStack(i, 1, 0);
         }
         remotePlayer.absMoveTo(d, d1, d2, f, f1);
         worldClient.addEntityToWorld(playerPacket.entityId, remotePlayer);
         remotePlayer.nickname = StringUtils.substring(playerPacket.nickname, 0, 32);
         remotePlayer.chatColor = playerPacket.chatColor;
+
+        remotePlayer.setHeldObject(playerPacket.heldObjectTag == null ? null : ICarriable.createAndLoadCarriable(remotePlayer, playerPacket.heldObjectTag));
     }
 
     @Override
@@ -387,6 +390,11 @@ public class ClientPacketHandler extends PacketHandler
             }
         }
     }
+    @Override
+    public void handleSetHotbarOffset(SetHotbarOffsetPacket setHotbarOffsetPacket)
+    {
+        mc.thePlayer.inventory.setHotbarOffset(setHotbarOffsetPacket.hotbarOffset, true);
+    }
 
     @Override
     public void handleDestroyEntity(RemoveEntityPacket packet29DestroyentityPacket)
@@ -982,6 +990,14 @@ public class ClientPacketHandler extends PacketHandler
         }
     }
 
+    @Override
+    public void handlePlayerHeldObject(SetHeldObjectPacket setHeldObjectPacket) {
+        Entity entity = getEntityByID(setHeldObjectPacket.entityID);
+        if (entity != null) {
+            entity.setHeldObject(setHeldObjectPacket.objectTag == null ? null : ICarriable.createAndLoadCarriable(entity, setHeldObjectPacket.objectTag));
+        }
+    }
+
     @Override
     public void handleCloseWindow(ContainerClosePacket containerClosePacket)
     {
@@ -1095,7 +1111,7 @@ public class ClientPacketHandler extends PacketHandler
     
     @Override
     public void handleBlockItemSwitch(SetCarriedItemPacket setCarriedItemPacket) {
-        mc.thePlayer.inventory.currentItem = setCarriedItemPacket.id;
+        mc.thePlayer.inventory.setCurrentItemIndex(setCarriedItemPacket.id, true);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/option/VolumeOption.java b/src/main/java/net/minecraft/client/option/VolumeOption.java
index 1a1959a39..272a6c0b2 100644
--- a/src/main/java/net/minecraft/client/option/VolumeOption.java
+++ b/src/main/java/net/minecraft/client/option/VolumeOption.java
@@ -9,7 +9,8 @@ import paulscode.sound.SoundSystem;
 public class VolumeOption extends FloatOption{
 	public final SoundCategory soundCategory;
 
-	public VolumeOption(@NotNull GameSettings gameSettings, String name, float value, SoundCategory soundCategory) {
+	//do *not* add @NotNull to gameSettings here, breaks modding for some abstract reason
+	public VolumeOption(GameSettings gameSettings, String name, float value, SoundCategory soundCategory) {
 		super(gameSettings, name, value);
 		this.soundCategory = soundCategory;
 	}
